/* Use sprintf to create scanf format string based 
 * on the size of the array used as input */
#include <stdio.h>
#include <string.h>
#define SIZE 30

int main(int argc, char *argv[]) {
	char dest_str[SIZE], src_str[SIZE];
	/* Since we want to print something in the format %XXXXs, 
	 * 20 characters are enough to cover the case of an array of
	 * 99,999,999,999,999,999 elements (saving 3 characters for
	 * %, s, and \0. This is more than enough... */
	char format_str[20];
	
	/* sprintf is similar to printf. It creates a string instead
	 * of printing to the output. It takes an extra parameter (the
	 * first one) which is the array of chars where the string will
	 * be stored */
	
	/* - %% to print %
	 * - %d with the parameter being SIZE-1 to accept a series of SIZE-1
	 *   characters at most (print SIZE-1 to format_str)
	 * - s to print s */
	sprintf(format_str, "%%%ds", SIZE-1);
	printf("Assembled string = %s\n", format_str);
	
	/* Read input string */
	printf("Enter string\n");
	
	/* Now the format specifier in scanf will change if we change SIZE */
	scanf(format_str, src_str);
	printf("The src string is %s\n", src_str);

	/* Copy the string in src_str to dest_str */
	strcpy(dest_str, src_str);
	
	/* Print the new string in dest_str and its length.*/
	printf("New dest string is %s with length %d\n", dest_str, strlen(dest_str));
	return(0);
}
